import { deepCopy } from "@/plugins/utils";

export const selectQuestion = {
  questionType: "SINGLE_ANSWER_QUESTION", // 2多选
  quesBody: null,
  quesOptions: [
    {
      number: 1,
      body: null,
    },
    {
      number: 2,
      body: null,
    },
    {
      number: 3,
      body: null,
    },
    {
      number: 4,
      body: null,
    },
  ],
  quesAnswer: null,
  comment: null,
};

export const booleanQuestion = {
  questionType: "BOOL_ANSWER_QUESTION",
  quesBody: null,
  quesAnswer: 0,
  comment: null,
};

export const fillBlankQuestion = {
  questionType: "FILL_BLANK_QUESTION",
  quesBody: {
    sections: [],
  },
  quesAnswer: [
    {
      index: 1,
      sections: [{ blocks: [{ type: "text", value: "电纺丝技术" }] }],
    },
    {
      index: 2,
      sections: [{ blocks: [{ type: "text", value: "电纺丝技术" }] }],
    },
  ],
  comment: { sections: [] },
};

export const textAnswerQuestion = {
  questionType: "TEXT_ANSWER_QUESTION",
  quesBody: {
    sections: [],
  },
  // only one
  quesAnswer: [
    {
      index: 1,
      sections: [{ blocks: [{ type: "text", value: "电纺丝技术" }] }],
    },
  ],
  comment: { sections: [] },
};
// 完型填空/听力/阅读理解
export const readingComprehensionQuestion = {
  questionType: "READING_COMPREHENSION",
  quesBody: {
    sections: [],
  },
  comment: { sections: [] },
  subQuestions: [],
  // answer: [{ number: 1, answer: [8] }],
};

// 段落匹配/选词填空
export const bankedClozeQuestion = {
  questionType: "BANKED_CLOZE",
  quesBody: {
    sections: [],
  },
  comment: { sections: [] },
  subQuestions: [
    // select_question
  ],
  quesOptions: [
    {
      number: 1,
      body: {
        sections: [{ blocks: [{ type: "text", value: "黑格尔" }] }],
      },
    },
    {
      number: 2,
      body: {
        sections: [{ blocks: [{ type: "text", value: "苏格拉底" }] }],
      },
    },
  ],
  param: { matchingMode: 1, matchingType: 1 },
  // 段落匹配: "param": { "matchingMode": 2, "matchingType": 2 },
  quesAnswer: [{ number: 1, answer: [8] }],
};

const models = {
  SINGLE_ANSWER_QUESTION: selectQuestion,
  MULTIPLE_ANSWER_QUESTION: Object.assign({}, selectQuestion, {
    questionType: "MULTIPLE_ANSWER_QUESTION",
  }),
  BOOL_ANSWER_QUESTION: booleanQuestion,
  FILL_BLANK_QUESTION: fillBlankQuestion,
  TEXT_ANSWER_QUESTION: textAnswerQuestion,
  READING_COMPREHENSION: readingComprehensionQuestion,
  LISTENING_QUESTION: Object.assign({}, readingComprehensionQuestion, {
    questionType: "LISTENING_QUESTION",
  }),
  CLOZE: Object.assign({}, readingComprehensionQuestion, {
    questionType: "CLOZE",
  }),
  PARAGRAPH_MATCHING: Object.assign({}, bankedClozeQuestion, {
    questionType: "PARAGRAPH_MATCHING",
  }),
  BANKED_CLOZE: bankedClozeQuestion,
};

export const getInitQuestionModel = (qtype) => {
  return {
    ...deepCopy(models[qtype]),
    courseId: "",
    difficulty: "易",
    quesProperties: [],
  };
};
